;
;This needs some modes of operation
;Off
;B1on
;B2on
;On
;Seq	- Boiler 1 first then boiler 2 
;		1 boiler when 2 temps are low
;		both boilers when 3 temps are low
;		off when none are low

;B 1	- Boiler 1 on when 2 temps are low, off when none are low
;B 2	- Boiler 2 on when 2 temps are low, off when none are low 



.include "p24FJ32GA002.inc"

config __CONFIG2, IESO_OFF & FNOSC_FRC & FCKSM_CSECMD & OSCIOFNC_ON & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_EC  
config __CONFIG1, JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & ICS_PGx1 & FWDTEN_OFF & WINDIS_OFF & FWPSA_PR32 & WDTPS_PS32768


.text 
	
max_display_mode = 4
max_op_mode = 6

max_set_temp	= 85 * 16	;sixteen times the degrees C
min_set_temp	= 30 * 16 	;sixteen times the degrees C
medium_accel_time = 256
fast_accel_time = 1024	;units of 1/64 th second

display32 = 0x900
display10 = 0x902
search_bit_count = 0x904
sensor_number	 = 0x906
presence_pulse_reg = 0x908
presence_pulse 		= 0x0
one_recieved_reg	= 0x908
one_recieved		= 0x1
boiler_1_last_reg = 0x908
boiler_1_last  = 0x2


temp_read			= 0x90a

sensor_0_status  = 0x910		; 3 16 bit registers
sensor_1_status  = 0x912
sensor_2_status  = 0x914
;sensor_0_temperature = 0x918	; 3 16 bit registers
sensor_find_progress = 0x91a
sensor_0_addr	 = 0x920		;12 16 bit registers
sensor_1_addr	 = 0x928
sensor_2_addr	 = 0x930
temp_0			= 0x938
temp_1			= 0x93A
temp_2			= 0x93C

sensor_temp_address_4 = 0x940
sensor_temp_address_3 = 0x942
sensor_temp_address_2 = 0x944
sensor_temp_address_1 = 0x946		;64 bits
sensor_temp_address_4_s  = 0x948
sensor_temp_address_3_s  = 0x94a
sensor_temp_address_2_s  = 0x94c
sensor_temp_address_1_s  = 0x94e	;64 bits

temp_set_0		= 0x950
temp_set_1		= 0x952
temp_set_2		= 0x954
temp_set_3		= 0x956	; the operation mode not a temperature

display_timer_count = 0x958
button_timer		= 0x95a
display_mode		= 0x95c
display_flash_timer = 0x95e
button_debounce_timer = 0x960
temp_being_adjusted = 0x962
scroll_progress		= 0x964
scroll_timer		= 0x966
display_status		=0x968	;this changes with time as opposed to display_mode which is changed by the button being pressed

sorted_temp_0		= 0x96A
sorted_temp_1	= 0x96c
sorted_temp_2	= 0x96e

;operation_mode = 0x970
timer_count		= 0x972

pushbutton_in_reg	= PORTA
pushbutton_in_tris	= TRISA
pushbutton_in		= 0x00		; to be decided

boiler_1_reg	= LATB
boiler_1		= 0x04
boiler_2_reg	= LATB
boiler_2		= 0x05



one_wire_out_port	 = LATB
one_wire		 = 3		;to be decided

one_wire_in_port	 = PORTB
one_wire_enable_port = TRISB
one_wire_OD_port	 = ODCB

	clr		TRISA
	clr		TRISB

	setm	AD1PCFG


;	bset	LATB, #4
;	bset	LATB, #5
	bset	one_wire_OD_port, #one_wire
	bset	pushbutton_in_tris, #pushbutton_in	


	mov		#0x2020, w0
	mov		w0, display32
	mov		w0, display10
	call	display


	mov		#0b1000000000010000, w0
	mov		w0, T1CON

	mov		#0b1000000000000000, w0
	mov		w0, T2CON				;turn on timer 2, prescale = 1

	clr		display_mode
	setm	button_timer

	mov		#(intro - scroll_start )/ 2, w0
	rcall	setup_scroll

	clr		sensor_find_progress




main_loop:
 	rcall		on_and_off_boiler
	rcall		read_temp
	rcall		check_button
	rcall		display_update

	bra			main_loop

display_update:

	bclr		SR, #C
	btss		scroll_timer, #0
	btg			SR, #C
	btss		TMR2, #15
	btg			SR, #C

;	btsc		SR, #C

	bra			NC, return_from_display_update
	inc			scroll_timer	;should increment it at about 125 Hz

;	bra			normal_display	;debug

;If scroll is in progress, do that
	cp0			scroll_progress
	bra			Z, normal_display

;increment scroll_timer with msb of timer2

	mov			#31, w0
	and			scroll_timer, wreg
	bra			NZ, return_from_display_update	;do something every 1/2 second

	mov			scroll_progress, w5
	rcall		data					;collect data into w4
	inc			scroll_progress
	cp0			w4
	bra			NZ, display_scroll		;display if not zero
	clr			scroll_progress			;otherwise stop
return_from_display_update:
	return

normal_display:
;this needs to display the temperature if the display_mode is zero
	cp0		display_mode
	bra		NZ, display_adjusting_mode

	mov		#255, w0
	and		scroll_timer, wreg
	btsc	SR, #Z
	inc		display_status

	mov		#4, w0
	cp		display_status
	btsc	SR, #C
	clr		display_status		;limit to 2

	mov		display_status, w0
	bra		w0
	bra		display_bottom_temp
	bra		display_mid_temp
	bra		display_top_temp
;	bra		display_operation_mode

display_operation_mode:
;	mov		operation_mode, w0
	mov		#6, w0			;point to op mode
	rcall	read_eeprom
display_operation_mode_adj:
	cp		w0, #7
	bra		C, op_mode_lookup_fault	;skip out if more than 6, the max operation mode
	mul.uu	w0, #3, w0				;each lookup is 3 lines long

	bra		w0	
op_mode_lookup_fault:		
	mov		#0x4F20, w1
	mov		#0x6666, w2			;"Off "
	bra		op_mode_lookup_done
	mov		#0x3142, w1
	mov		#0x6E6F, w2			;"B1on"
	bra		op_mode_lookup_done
	mov		#0x3242, w1
	mov		#0x6E6F, w2			;"B2on"
	bra		op_mode_lookup_done
	mov		#0x4F20, w1
	mov		#0x206e, w2			;" On "
	bra		op_mode_lookup_done
	mov		#0x6553, w1
	mov		#0x2071, w2			;"Seq "
	bra		op_mode_lookup_done
	mov		#0x4220, w1
	mov		#0x2031, w2			;" B1 "
	bra		op_mode_lookup_done
	mov		#0x4220, w1
	mov		#0x2032, w2			;" B2 "
;	bra		op_mode_lookup_done

op_mode_lookup_done:
	mov		w1, display32
	mov		w2, display10
	bra		display





display_bottom_temp:
	mov		#0x42, w0
	mov		sorted_temp_0, w1
	bra		display_any_temp


display_top_temp:
	mov		#0x54, w0
	mov		sorted_temp_2, w1
	bra		display_any_temp

display_mid_temp:
	mov		#0x4D, w0
	mov		sorted_temp_1, w1

display_any_temp:


display_any_adjustment:

;	mov		button_timer, w1	;debug!!
;	btsc	w1, #15
;	neg		w1, w1

	mov		#0x7ff, w2
	and		w1, w2, w1

	mov		w0, display32
	and		w1, #0x0f, w2
	mul.uu	w2, #10, w2
	and		#0xf0, w2
	sl		w2, #4, w2		;w2 is now the decimal fraction * 0x100

	asr		w1, #4, w0
	mov		#10, w4
	repeat	#17
	div.uw	w0, w4			;w0 is the tens, w1 is the units

	and		#0x0f, w0
	add		#0x30, w0
	swap	w0
	
	ior		display32		;put the units ready to display in ascii
	ior		w1, w2, w3
	mov		#0x3030, w0
	ior		w0, w3, w0
	mov		w0, display10

	bra		display

display_adjusting_mode:
;scroll_timer is used to flash as required
;the first digit is t, m or b depnding on display_mode
;That digit flashes if display_mode, #15 is set
;The last 3 digits are the set temperature

	mov		display_mode, w2
	and		w2, #7, w2

	mov		#max_display_mode+1, w0
	cp		w0, w2
	btss	SR, #C
	clr		w2			;limit to 3

	bra		w2
	nop
	bra		display_bottom_adj
	bra		display_mid_adj
	bra		display_top_adj
;	bra		display_op_mod_adj

display_op_mod_adj:
	mov		temp_being_adjusted, w0
	btsc	display_mode, #15			;Only flash if being adjusted
	btsc	scroll_timer, #6			;the display will look the same during the normal 
	bra		display_operation_mode_adj		;rotation and when the user scrolls through the settings
	mov		#0x2020, w1
	mov		#0x2020, w2
	bra		op_mode_lookup_done


display_bottom_adj:
	mov		#0x62, w0
	bra		display_any_adj


display_top_adj:
	mov		#0x74, w0
	bra		display_any_adj

display_mid_adj:
	mov		#0x6D, w0

display_any_adj:
	mov		temp_being_adjusted, w1

	btss	display_mode, #15
	bra		display_any_adjustment

	btss	scroll_timer, #6
	mov		#0x20, w0

	bra		display_any_adjustment


setup_scroll:
	mov		w0, scroll_progress
	clr		scroll_timer
	return	


check_button:

minimum_off_time	= 3
minumum_on_time		= 3
long_press_time		= 40
long_off_time		= 32
time_out			= 1000
off_time_for_store  = 160

;This uses timer 2 to decide what it happening
;timer 2 takes 16 milli seconds to time out

	btss	IFS0, #T2IF
	return
	bclr	IFS0, #T2IF

	btsc		pushbutton_in_reg, #pushbutton_in
	bra			button_pressed

;we get here if the button isn't pressed
;See if the counter is positive
	btss		button_debounce_timer, #15
	clr			button_debounce_timer		;zero any up count

	dec			button_debounce_timer		

 	mov			#0x10000 - minimum_off_time, w0
	cp			button_debounce_timer		;see if we are far enough down
	bra			C, return_from_button
	mov			w0, button_debounce_timer		; limit negative 

	bra			debounced_button_released

button_pressed:

	btsc		button_debounce_timer, #15
	clr			button_debounce_timer		;zero any down count

	inc			button_debounce_timer		

 	mov			#minimum_off_time, w0
	cp			button_debounce_timer		;see if we are far enough up
	bra			NC, return_from_button
	mov			w0, button_debounce_timer		; limit negative 

	bra			debounced_button_pressed

return_from_button:
	return


debounced_button_released:
;When the button is first released, advance the mode if it isn't in adjusting mode

;	bclr	boiler_1_reg, #boiler_1	

	bclr	display_mode, #14

	btsc	button_timer, #15
	bra		not_first_release

	clr		button_timer

	btsc	display_mode, #15	;flag to say that it is in adjusting mode
	bra		not_first_release	
	
	inc		display_mode	
	mov		#max_display_mode+1, w0
	cp		display_mode
	btsc	SR, #C
	clr		display_mode


	sl		display_mode, wreg	;point to eeprom
	dec2	w0, w0
	rcall	read_eeprom

	mov		display_mode, w1
	cp		w1, #4		
	bra		Z, apply_operation_mode_limits
	rcall	apply_limits

limits_applied:

	mov		w0, temp_being_adjusted

not_first_release:
	dec		button_timer
	btss	button_timer, #15
	inc		button_timer
	
;Now we see if it is long enough that we should store a reading if in adjusting mode

	mov		#0x10000 - time_out, w0
	cp		button_timer		;see if we are far enough down
	bra		C, check_for_update

	clr		display_mode
	return

apply_operation_mode_limits:
	mov		#max_op_mode+1, w1
	cp		w1, w0
	btss	SR, #C
	clr		w0
	bra		limits_applied

check_for_update:

	btss	display_mode, #15	;flag to say that it is in adjusting mode
	bra		return_from_button_released

	mov		#0x10000 - off_time_for_store, w0
	cp		button_timer		;see if we are far enough down
	bra		NZ, return_from_button_released


;Now we look at the temporary value and see if it is different from the stored one
	bclr	display_mode, #15		;put it out of adjusting mode

	sl		display_mode, wreg	;point to eeprom
	dec2	w0, w0
	bclr	w0, #0
	rcall	read_eeprom
	cp		temp_being_adjusted		

;	bra		no_adjustment_done

	bra		Z, no_adjustment_done	;do nothing if no change
	
	clr		w3
	mov		#temp_set_0, w2
	
read_loop:
	mov		w3,  w0
	rcall	read_eeprom
	mov		w0, [w2++]
	inc2	w3, w3
	cp		w3, #8
	bra		NC, read_loop				;read all the set temperatures

	sl		display_mode, wreg	;point to eeprom
	dec2	w0, w0
	mov		#temp_set_0, w2
	add		w2, w0, w2				;point to one of the temperatures
	
	mov		temp_being_adjusted, w0
	mov		w0, [w2]

	rcall	block_erase
	rcall	write_eeprom
	
	mov		#(updated - scroll_start )/ 2, w0
	bra		setup_scroll

no_adjustment_done:
	mov		#(no_change - scroll_start)/2, w0
	bra		setup_scroll

return_from_button_released:
	return



debounced_button_pressed:
;This waits for the button to have been pressed for a long time,
;and moves onto adjust mode

;	bset	boiler_1_reg, #boiler_1

	btsc	button_timer, #15
	setm	button_timer	
	
	inc		button_timer
	btsc	button_timer, #15	
	dec		button_timer

	btsc	display_mode, #15
	bra		adjust_stuff

	cp0		display_mode
	bra		Z, return_from_button_pressed	;there is no adjustment from default display

	mov		#long_press_time, w0
	cp		button_timer			;see if we are far enough up
	bra		NC, return_from_button_pressed

	bset	display_mode, #15		;put it into adjusting mode

	bset	display_mode, #14		;flag to say do not increment until the button is released
return_from_button_pressed:
	return	

adjust_stuff:
	btsc	display_mode, #14
	bra		return_from_button_pressed

	cp0		button_timer
	bra		NZ, not_the_first_press
	
;Here the button has just been pressed
	inc		button_timer

	mov		display_mode, w0
	and		#0xff, w0
	cp		w0, #4
	bra		Z, first_press_op_mode_adj

	rcall	inc_temp
	
	mov		#max_set_temp+1, w0
	cp		temp_being_adjusted
	mov		#min_set_temp, w0
	btsc	SR, #C
	mov		w0, temp_being_adjusted
	return

first_press_op_mode_adj:
	inc		temp_being_adjusted
	mov		#max_op_mode+1, w0
	cp		temp_being_adjusted
	btsc	SR, #C
	clr		temp_being_adjusted
	return

not_the_first_press:

	mov		display_mode, w0
	and		#0xff, w0
	cp		w0, #4							;there is no acceleration when
	bra		Z, return_from_button_pressed	;operation mode is being adjusted

	mov		#max_set_temp, w0
	cp		temp_being_adjusted
	bra		C, return_from_button_pressed	;do not roll when accelerated
	
	mov		#medium_accel_time, w0
	cp		button_timer
	bra		C, medium_or_fast_adjust
	mov		#63, w0
compare_accel:
	and		button_timer, wreg
	bra		NZ, return_from_button_pressed

inc_temp:
;now we need to incremtent temp_being adjusted more for some values
;as the display goes up 10 increments for 16 increments of temp_being adjusted

	mov		temp_being_adjusted, w0
	and		w0, #7, w0
	clr		w1	
	bra		w0
	btg		w1, #0		;0		
	btg		w1, #0		;1
	btg		w1, #0		;2
	nop					;3
	btg		w1, #0		;4
	btg		w1, #0		;5
	nop					;6
;	nop					;7

	btsc	w1, #0
	inc		temp_being_adjusted
	inc		temp_being_adjusted
	return

medium_or_fast_adjust:
	mov		#fast_accel_time, w0
	cp		button_timer
	mov		#15, w0		;1/10 deg C every 1/4 second
	btsc	SR, #C		;select what to compare with
	mov		#3, w0		;1/10 deg C every 1/16 second
	bra		compare_accel

on_and_off_boiler:
;This needs to decide when to turn the boiler on and off
;Off
;B1on
;B2on
;On
;Seq	- Boiler 1 first then boiler 2 
;		1 boiler when 2 temps are low
;		both boilers when 3 temps are low
;		off when none are low

;B 1	- Boiler 1 on when 2 temps are low, off when none are low
;B 2	- Boiler 2 on when 2 temps are low, off when none are low 

	mov		#6, w0			;point to op mode
	rcall	read_eeprom
	mov		#max_op_mode+1, w1
	cp		w0, w1
	btsc	SR, #C
	clr		w0
;	mov		w0, operation_mode


	bra		w0
	bra		turn_off_both
	bra		boiler_1_on
	bra		boiler_2_on
	bra		turn_on_both
	bra		sequence
	bra		boiler_1_only
;	bra		boiler_2_only

boiler_2_only:
	rcall	collect_no_of_high_temps
	bra		w3
	bra		boiler_2_on
	bra		boiler_2_on
	bra		turn_on_nothing
	bra		turn_off_both

boiler_1_only:
	rcall	collect_no_of_high_temps
	bra		w3
	bra		boiler_1_on
	bra		boiler_1_on
	bra		turn_on_nothing
	bra		turn_off_both

sequence:
	rcall	collect_no_of_high_temps

;now w3 is the number of temperatures above setpoint
	bra		w3
	bra		turn_on_both
	bra		turn_on_one
	bra		turn_on_nothing
;	bra		turn_off_both

turn_off_both:
	bclr	boiler_1_reg, #boiler_1
	bclr	boiler_2_reg, #boiler_2
turn_on_nothing:
	return

boiler_1_on:
	bset	boiler_1_reg, #boiler_1
	bclr	boiler_2_reg, #boiler_2
	return

boiler_2_on:
	bclr	boiler_1_reg, #boiler_1
	bset	boiler_2_reg, #boiler_2
	return

turn_on_both:
	bset	boiler_1_reg, #boiler_1
	bset	boiler_2_reg, #boiler_2
	return

turn_on_one:
;This only does anything if it finds no boilers on
	btsc	boiler_1_reg, #boiler_1
	return
	btsc	boiler_2_reg, #boiler_2
	return
;now it is time to turn on a boiler
	btss	boiler_1_last_reg, #boiler_1_last
	bset	boiler_1_reg, #boiler_1
	btsc	boiler_1_last_reg, #boiler_1_last
	bset	boiler_2_reg, #boiler_2				;turn on a boiler

	btg		boiler_1_last_reg, #boiler_1_last	;toggle flag to use other one next time
	return


collect_no_of_high_temps:
	clr		w3			;accumulator for number below settings
	mov		#3, w4		;pointer to which temperature this is on
	mov		#sorted_temp_2, w2
temp_compare_loop:
	dec		w4, w4		;loop counter
	sl		w4, #1, w0	;point to eeprom
	rcall	read_eeprom
	rcall	apply_limits
	cp		w0, [w2--]		;compare temperature with set value
	btss	SR, #C
	inc		w3, w3			;increment if temperatures are above setpoint
	cp0		w4
	bra		NZ, temp_compare_loop
	and		#3, w3
	return







read_eeprom:
	and		#0b0110, w0		;limit to just the few numbers that we store.
	mov		#psvoffset(eeprom_addr)+0x8000, w1
	add		w0, w1, w0

	mov		#psvpage(eeprom_addr), w1
	mov		w1, _PSVPAG
	bset	CORCON, #2	; #PSV should work			;set program space visisbility

	mov		w0, w1
	bclr	w1, #0	;make sure that the result it even
	mov		[w1], w0
	return








display_scroll:

	mov		display32, w0
	lsr		w0, #8, w0
	
	mov		display10, w1
	sl		w1, #8, w2
	ior		w0, w2, w0

	mov		w0, display32

	mov		display10, w0
	lsr		w0, #8, w1

	sl		w4, #8, w0
	ior		w0, w1, w0
	mov		w0, display10	
	
;	bra		display


display:
;This takes display32 and display10 and puts them on to the display
;each has the lsb as the first character
	mov		#0b1111111000000000, w2
	mov		display32, w0
	sl		w0, #9, w0
	and		w0, w2, w0
	mov		LATB, w1
	and		#0b0000000111111111, w1
	ior		w0, w1, w0
	bset	w0, #8
	bset	w0, #7
	bset	w0, #6	;address = 3
	mov		w0, LATB
	nop	
	bclr	LATB, #8
	nop	
	bset	LATB, #8	;LATch data

	mov		display32, w0
	sl		w0, #1, w0
	and		w0, w2, w0
	mov		LATB, w1
	and		#0b0000000111111111, w1
	ior		w0, w1, w0
	bset	w0, #8
	bset	w0, #7
	bclr	w0, #6	;address = 2
	mov		w0, LATB
	nop	
	bclr	LATB, #8
	nop	
	bset	LATB, #8	;LATch data

	mov		display10, w0
	sl		w0, #9, w0
	and		w0, w2, w0
	mov		LATB, w1
	and		#0b0000000111111111, w1
	ior		w0, w1, w0
	bset	w0, #8
	bclr	w0, #7
	bset	w0, #6	;address = 2
	mov		w0, LATB
	nop	
	bclr	LATB, #8
	nop	
	bset	LATB, #8	;LATch data

	mov		display10, w0
	sl		w0, #1, w0
	and		w0, w2, w0
	mov		LATB, w1
	and		#0b0000000111111111, w1
	ior		w0, w1, w0
	bset	w0, #8
	bclr	w0, #7
	bclr	w0, #6	;address = o
	mov		w0, LATB
	nop	
	bclr	LATB, #8
	nop	
	bset	LATB, #8	;LATch data
	return

	

data:
	mov		#(scroll_end - scroll_start)/2, w0
	cp		w0, w5
	bra		C, continue_data
	clr		w5
	clr		w4
	clr		scroll_progress
	return




continue_data:
	bra		w5
scroll_start:
	nop
intro:
	retlw	#0x48, w4	;H
	retlw	#0x65, w4	;e
	retlw	#0x6c, w4	;l
	retlw	#0x6c, w4	;l
	retlw	#0x6f, w4	;o
	retlw	#0x20, w4	;
	retlw	#0x42, w4	;B
	retlw	#0x69, w4	;i
	retlw	#0x6c, w4	;l
	retlw	#0x6c, w4	;l
	retlw	#0x00, w4

updated:
	retlw	#0x55, w4	;U
	retlw	#0x70, w4	;p
	retlw	#0x64, w4	;d
	retlw	#0x61, w4	;a
	retlw	#0x74, w4	;t
	retlw	#0x65, w4	;e
	retlw	#0x64, w4	;d
	retlw	#0x20, w4	;
	retlw	#0x20, w4	;
	retlw	#0x20, w4	;
	retlw	#0x20, w4	;
	retlw	#0x00, w4

no_change:
	retlw	#0x4e, w4	;N
	retlw	#0x6f, w4	;o
	retlw	#0x20, w4	; 
	retlw	#0x63, w4	;c
	retlw	#0x68, w4	;h
	retlw	#0x61, w4	;a
	retlw	#0x6e, w4	;n
	retlw	#0x67, w4	;g
	retlw	#0x65, w4	;e
	retlw	#0x20, w4	;
	retlw	#0x20, w4	;
	retlw	#0x20, w4	;
	retlw	#0x20, w4	;
	retlw	#0x00, w4

scroll_end:




read_temp:
;Here we have to read temperatures repeatedly

find_sensors:
;This is where we find what sensors are fitted.

	mov		#(sensor_find_end - sensor_find_start)/2, w0
	cp		sensor_find_progress
	bra		C, sensors_found

	mov		sensor_find_progress, wreg

;	bset	PORTB, #0
;	rcall	short_pause
;	rcall	short_pause
;	bclr	PORTB, #0
;	rcall	short_pause
;	bset	PORTB, #0
;	rcall	short_pause
;	rcall	short_pause
;	bclr	PORTB, #0
;	rcall	short_pause

;	btsc	sensor_find_progress, #2
;	bset	PORTB, #0
;	rcall	short_pause
;	bclr	PORTB, #0
;	rcall	short_pause
;
;	btsc	sensor_find_progress, #1
;	bset	PORTB, #0
;	rcall	short_pause
;	bclr	PORTB, #0
;	rcall	short_pause
;
;	btsc	sensor_find_progress, #0
;	bset	PORTB, #0
;	rcall	short_pause
;	bclr	PORTB, #0


	bra		w0
sensor_find_start:
	bra		start_total_reset
	bra		setup_sensor_find
	bra		start_temperature_reading
	bra		check_temperature_timer
	bra		read_temperature_1
	bra		read_temperature_2
	bra		sort_temps

sensor_find_end:
sensors_found:
	clr		sensor_find_progress
	return

start_total_reset:
	clr		timer_count
	bclr	IFS0, #T1IF
	bclr	one_wire_out_port, #one_wire
	inc		sensor_find_progress


setup_sensor_find:
	btss	IFS0, #T1IF
	return

	mov		#sensor_0_status, w0
	repeat	#2
	clr		[w0++]				;clear the status registers

;	mov		#temp_0, w0
;	repeat	#2
;	clr		[w0++]	


	mov		#sensor_0_addr, w0
	repeat	#11
	clr		[w0++]				;clear the address registers

resolve_next_sensor:
;This needs to find the next incomplete sensor 

	mov		#3, w2
	
	mov		#sensor_0_status-2, w4
	mov		#sensor_0_addr+6, w3

try_next_sensor:
	btss	[++w4], #6
	bra		unfinnished_sensor_found
	add		#8, w3			;point to next address

	dec		w2, w2
	bra		NZ, try_next_sensor
	return	


unfinnished_sensor_found:
	rcall	reset_pulse
	rcall	check_presence_pulse
	btss	presence_pulse_reg, #presence_pulse
	bra		no_sensors			;skip out if nothing fitted
	mov		#0xf0, w1
	rcall	byte_send

;	mov		#sensor_0_status, w4
;	mov		#sensor_0_addr+6, w3
;	bra		bit_bypassing_done ;debug

;This may need a bit of a structure change.
;If w5 is not zero, we need to go trough w5 bits and go with the contents of [w3]
;w5 is non-zero here when a sensor has been spawned, so we expect a clash and we have
;to go with what is in [w3] or we keep going the same way

	mov		#sensor_temp_address_4, w2
	sub		#8, w3			;point to msb
	repeat	#3
	mov		[++w3], [w2++]	;collect 64 bits 
	mov		[w4], w5			;collect count of bits that have been resolved
	and		#63, w5				;only reverse unfinished sensors
	
bit_reverse_loop:
	bra		Z, reversing_done

	rrc		sensor_temp_address_4
	rrc		sensor_temp_address_3 
	rrc		sensor_temp_address_2 
	rrc		sensor_temp_address_1 
	rlc		sensor_temp_address_1_s
	rlc		sensor_temp_address_2_s
	rlc		sensor_temp_address_3_s
	rlc		sensor_temp_address_4_s

	dec		w5, w5
	bra		bit_reverse_loop

reversing_done:
	mov		[w4], w5			;collect count of bits that have been resolved	
	and		#63, w5				;only reverse unfinished sensors

	cp0		w5
	bra		Z, bit_bypassing_done
bypass_next_bit:
	clr		w2					;stores what has been recieved
	rcall	recieve_bit
	btsc	one_recieved_reg, #one_recieved
	bset	w2, #1	;see if there are any further sensors with a 1 in the next place

	rcall	recieve_bit
	btsc	one_recieved_reg, #one_recieved
	bset	w2, #0	;see if there are any further sensors with a 0 in the next place

	btsc	sensor_temp_address_1_s, #0
	bra		resolved_bit_is_1
	
	btsc	w2, #1
	bra		delete_this_sensor

	rcall	send_0
	bra		end_of_resolved_bit

resolved_bit_is_1:
	btsc	w2, #0
	bra		delete_this_sensor

	rcall	send_1
end_of_resolved_bit:
	rrc		sensor_temp_address_4_s
	rrc		sensor_temp_address_3_s 
	rrc		sensor_temp_address_2_s 
	rrc		sensor_temp_address_1_s

	dec		w5, w5
	bra		NZ, bypass_next_bit


bit_bypassing_done:


search_next_bit:
	clr		w2					;stores what has been recieved
	rcall	recieve_bit
	btsc	one_recieved_reg, #one_recieved
	bset	w2, #1	;see if there are any further sensors with a 1 in the next place

	rcall	recieve_bit
	btsc	one_recieved_reg, #one_recieved
	bset	w2, #0	;see if there are any further sensors with a 0 in the next place

;Now we can have a lookup table to decide what to do

	bra		w2

	bra		spawn_a_sensor	
	bra		add_a_zero
	bra		add_a_one
	return		;debug
	bra		no_more_sensors
spawn_a_sensor:


	btsc	[w4], #6	;stop at 64
	return

;This needs to copy the present sensor to a blank one
;Firstly, find a blank sensor

	mov		#sensor_0_status, w0
	mov		#sensor_0_addr+6, w1
	mov		#3, w2
	
try_next_sensor_spawn:
	dec		w2, w2
	cp0		[w0++]			;point to next sensor
	bra		Z, blank_found

	add		#8, w1	
	cp0		w2
	bra		NZ, try_next_sensor_spawn

	bra		no_more_sensors_to_spawn

blank_found:
	mov		[w4], [--w0]		;collect status
	repeat  #3	
	mov		[w3--], [w1--]	;collect number

	add		#8, w3
	add		#8, w1

	;now we need to add a 1 to one of these and a zero to the other

	bclr	SR, #C
	rlc		[w3], [w3--]
	rlc		[w3], [w3--]
	rlc		[w3], [w3--]
	rlc		[w3], [w3--]	;repeat doesn't work here for some reason
	inc		[w4], [w4]	;increment the bit count

	mov		w1, w3
	mov		w0, w4	;point to other sensor
;This leads straight into add_a_one
no_more_sensors_to_spawn:	
add_a_one:
	bset	SR, #C
	bra		add_a_bit


add_a_zero:
	bclr	SR, #C
add_a_bit:

	rlc		[w3], [w3--]
	rlc		[w3], [w3--]
	rlc		[w3], [w3--]
	rlc		[w3], [w3--]	;repeat doesn't work here for some reason

	add		#8, w3		;point to the lsb of whichever sensor we are on

	inc		[w4], [w4]	;increment the bit count

	btsc	[w4], #6	;stop at 64
	bra		check_for_more_sensors;		return			;this will go on to look for more sensors
	
	btss	[w3], #0
	rcall	send_0

	btsc	[w3], #0
	rcall	send_1		;send the most recent bit


	bra		search_next_bit


check_for_more_sensors:
;This has to see if there are any sensors with started
;but not finished addresses
;If there are, point to them and start resolving address
;If not, progress to reading temperatures

	mov		#sensor_0_status-2, w4
	mov		#sensor_0_addr+6, w3
	mov		#3, w1
try_next_unfinished_sensor:
	mov		[++w4], w2
	and		#63, w2
	bra		NZ, resolve_next_sensor
	add		#8, w3	
	dec		w1, w1
	bra		NZ, try_next_unfinished_sensor 
;	bra		no_more_sensors

no_more_sensors:
;Now we should have 3 sensors, so we need to measure all the temperatures
	inc		sensor_find_progress
	bset	PORTB, #1
	rcall	short_pause
	bclr	PORTB, #1
	return	


start_temperature_reading:


	rcall	reset_pulse
	rcall	check_presence_pulse
	mov		#0xcc, w1
	rcall	byte_send	;send skip rom command
	
	bset	PORTB, #0
	rcall	short_pause
	bclr	PORTB, #0




	mov		#0x44, w1
	rcall	byte_send	;start conversion command

	bclr	one_wire_OD_port, #one_wire
	bset	one_wire_out_port, #one_wire
	bclr	one_wire_enable_port, #one_wire
	inc		sensor_find_progress
	clr		TMR1
	clr		timer_count
	bclr	IFS0, #T1IF
	return	


read_temperature_1:
	mov		#sensor_1_addr, w4
	mov		#temp_1, w5
	mov		#sensor_1_status, w6
	bra		read_any_temperature

read_temperature_2:
	mov		#sensor_2_addr, w4
	mov		#temp_2, w5
	mov		#sensor_2_status, w6
	bra		read_any_temperature

check_temperature_timer:
;8 MHz, so timer increments every 8 * 0.25 us = 2 us
;so this times out at 1/8 second.

	btss	IFS0, #T1IF
return_from_check_timer:
	return
	bclr	IFS0, #T1IF


	inc		timer_count
	mov		#6, w0
	cp		timer_count
	bra		NC, return_from_check_timer

;	bra		display_temps	;debug

;Now we can read the temperatures

	bset	one_wire_OD_port, #one_wire

	mov		#sensor_0_addr, w4
	mov		#temp_0, w5
	mov		#sensor_0_status, w6

read_any_temperature:
	inc		sensor_find_progress
	btss	[w6], #6
	return	;			skip out if no sensor
	rcall	reset_pulse
	rcall	check_presence_pulse
	mov		#0x55, w1
	rcall	byte_send	;send match rom command


;	mov		#0xCC, w1
;	rcall	byte_send	;send skip rom command
;	bra		read_scratchpad

	mov		#sensor_temp_address_4, w3

	repeat	#3
	mov		[w4++], [w3++]	;collect address 

	mov		#64, w1

rom_match_loop:	
	btss	sensor_temp_address_4, #15
	rcall	send_0
	btsc	sensor_temp_address_4, #15
	rcall	send_1

	rlc		sensor_temp_address_1
	rlc		sensor_temp_address_2
	rlc		sensor_temp_address_3
	rlc		sensor_temp_address_4

	dec		w1, w1
	bra		NZ, rom_match_loop


read_scratchpad:
	mov		#0xBE, w1
	rcall	byte_send	;send read scratchpad


;	mov		#0x33, w1
;	rcall	byte_send	;send read rom

	mov		#16, w1
temp_recieve_loop:
	rrc		[w5], [w5]	
	rcall	recieve_bit
	bclr	[w5], #15
	btsc	one_recieved_reg, #one_recieved
	bset	[w5], #15
	dec		w1, w1
	bra		NZ, temp_recieve_loop
;	mov		#0x1234, w0
;	mov		w0, temp_0
	
	return

sort_temps:
	clr		sensor_find_progress
;here the temperatures are sorted (Hat?)

	mov		temp_0, w0
	mov		temp_1, w1
	mov		temp_2, w2

	cp		w2, w1
	btss	SR, #C
	exch	w1, w2	;w2 is now the larger

	cp		w2, w0
	btss	SR, #C
	exch	w0, w2	;w2 is now the larger

	cp		w1, w0
	btss	SR, #C
	exch	w0, w1	;w1 is now the larger

	mov		w0, sorted_temp_0
	mov		w1,	sorted_temp_1
	mov		w2, sorted_temp_2

	return

	
	


	clr		sensor_find_progress
	mov		temp_0, w0
	asr		w0, #3, w3
	and		#0x0f, w3
		
	mov		temp_1, w0
	sl		w0, #1, w0
	and		#0xf0, w0
	ior		w0, w3, w3

	mov		temp_2, w0
	and		#0x78, w0
	sl		w0, #5, w0
	ior		w0, w3, w3

	mov		#0x1000, w0
	btsc	sensor_0_status, #6
	add		w0, w3, w3
	btsc	sensor_1_status, #6
	add		w0, w3, w3
	btsc	sensor_2_status, #6
	add		w0, w3, w3

	bra		display_w3


;	clr		 w1
;read_all_temps_loop:
;	sl		w1, #2, w4
;	mov		#sensor_0_addr, w3
;	add		w4, w3, w3				;point to address
;	mov		#sensor_0_status, w4
;	add		w1, w4, w4				;point to status
;	btss	[w4], #6
;	bra		skip_this_sensor
;	
;	rcall	read_temp_at_w3
;	mov		#sensor_0_temperature, w2
;	add		w1, w2, w2
;	mov		temp_read, wreg
;	mov		w0, [w2]








;skip_this_sensor:
;	inc		w1, w1
;	cp		w1, #3
;	bra		NZ, read_all_temps_loop




	rcall	reset_pulse
	rcall	check_presence_pulse
	mov		#0xcc, w1
	rcall	byte_send	;send skip rom command
	
	mov		#0x44, w1
	rcall	byte_send	;start conversion command

	bclr	one_wire_OD_port, #one_wire
	bset	one_wire_out_port, #one_wire
	inc		sensor_find_progress
;the timer needs setting here



	mov		#16, w1				;one second pause
second_loop:
	mov		#65535, w0
	rcall	w0_pause
	dec		w1, w1
	bra		NZ, second_loop		

	rcall	reset_pulse
	rcall	check_presence_pulse
	mov		#0x55, w1
	rcall	byte_send	;send match rom command
	
	rcall	address_at_w3

	mov		0xbe, w1
	rcall	byte_send		;read scratchpad

	mov		#16, w1				;one second pause
byte_read_loop:
	rcall	recieve_bit
	sl		w2, w2
	bclr	w2, #0
	btsc	one_recieved_reg, #one_recieved
	bset	w2, #0

	dec		w1, w1
	bra		NZ, byte_read_loop	

	return








check_presence_pulse:
	bclr	presence_pulse_reg, #presence_pulse
	mov		#60, w0
	call	w0_pause

	btss	one_wire_in_port, #one_wire
	bset	presence_pulse_reg, #presence_pulse


	mov		#400, w0
	call	w0_pause
	return	




reset_pulse:
	bclr	one_wire_out_port, #one_wire
	mov		#500, w0
	rcall	w0_pause
	bset	one_wire_out_port, #one_wire
	return

w0_pause:
;This needs to sit here for w0 microcseconds
;At 9.8304 MHz that is about 5 steps per microsecond
	bra		$+2
	dec		w0, w0
	bra		NZ, w0_pause
	return	

word16_send:
	mov		#16, w6
	bra		byte_send_loop
byte_send:
	mov		#8, w6
byte_send_loop:
	btss	w1, #0
	rcall	send_0
	btsc	w1, #0
	rcall	send_1
	lsr		w1, w1
	dec		w6, w6
	bra		NZ, byte_send_loop
	return

send_0:
	mov		#65, w0
send_either:
	bclr	one_wire_out_port, #one_wire
	rcall	w0_pause
	bset	one_wire_out_port, #one_wire
	mov		#10, w0
	rcall	w0_pause	
	return

send_1:
	mov		#1, w0
	rcall	send_either

	mov		#65, w0
	bra		w0_pause

recieve_bit:
;This sends a really short pulse
;then waits 15 us and samples the line
;finaly waiting to give a total bit time of 60 us if neede
	bclr	one_recieved_reg, #one_recieved
	mov		#1, w0
	rcall	send_either
	mov		#4, w0
	rcall	w0_pause
	btsc	one_wire_in_port, #one_wire
	bset	one_recieved_reg, #one_recieved
	mov		#45, w0
;	btss	one_recieved_reg, #one_recieved
	bra		w0_pause
	return

address_at_w3:
	add		w3, #6, w6

	mov		[w6--], w1
	rcall	word16_send
	mov		[w6--], w1
	rcall	word16_send
	mov		[w6--], w1
	rcall	word16_send
	mov		[w6--], w1
	rcall	word16_send			;send 64 bit address
	
no_sensors:
	bra		sort_temps
delete_this_sensor:
	return

trim_and_hex_2_ascii:	
	and		#0b00001111, w0

hex_2_ascii:
	add.b		#(0x100 - 10), w0		;this makes 0x9 into 0xff and 0x0a to 0x00
	btsc		SR, #C
	add.b		#7, w0				;"A" -"9"-1			;this makes 0x0 to 0x5 into strange positive numbers 
	add.b		#58, w0				;this converts 0xff into "9" and the stange positive numbers into "A" to "F"
	return

display_w3:

	lsr			w3, #4, w0
	call		trim_and_hex_2_ascii
	mov			w0, w1
	
	lsr			w3, #0, w0
	call		trim_and_hex_2_ascii
	sl			w0, #8, w0

	ior			w1, w0, w0
	mov			w0, display10

	lsr			w3, #12, w0
	call		trim_and_hex_2_ascii
	mov			w0, w1
	
	lsr			w3, #8, w0
	call		trim_and_hex_2_ascii
	sl			w0, #8, w0
	ior			w1, w0, w0
	mov			w0, display32

	bra			display

short_pause:
	bra		$+2
	return
	
apply_limits:
	mov		#min_set_temp, w1
	cp		w0, w1
	btss	SR, #C
	mov		w1, w0

	mov		#max_set_temp, w1
	cp		w0, w1
	btsc	SR, #C
	mov		w1, w0				;apply limits
	return

block_erase:
;This erases up to eeprom_addr + 0x3fe

eeprom_addr = 0x1000

; Set up NVMCON for block erase operation
	MOV 	#0x4042, W0 ;
	MOV 	W0, NVMCON ; Initialize NVMCON
; Init pointer to row to be ERASED
	MOV 	#tblpage(eeprom_addr), W0 ;
	MOV 	W0, TBLPAG ; Initialize PM Page Boundary SFR
	MOV 	#tbloffset(eeprom_addr), W0 ; Initialize in-page EA[15:0] pointer
	TBLWTL 	W0, [W0] ; Set base address of erase block

	MOV 	#0x55, W0
	MOV 	W0, NVMKEY ; Write the 55 key
	MOV 	#0xAA, W1 ;
	MOV 	W1, NVMKEY ; Write the AA key
	BSET 	NVMCON, #WR ; Start the erase sequence
	NOP 				; Insert two NOPs after the erase
	NOP					 ; command is asserted
	btsc	NVMCON, #WR
	bra		$-2
	nop
	nop

	return


write_eeprom:
	MOV 	#0x4001, W0 ;
	MOV 	W0, NVMCON ; Set up NVMCON for row programming operations
; Set up a pointer to the first program memory location to be written
; program memory selected, and writes enabled
	MOV 	#0x0000, W0 ;
	MOV 	W0, TBLPAG ; Initialize PM Page Boundary SFR
	MOV 	#eeprom_addr, W0 ; An example program memory address
; Perform the TBLWT instructions to write the latches
; 0th_program_word
	MOV		temp_set_0, W2 ;
	clr		W3 ;
	TBLWTL 	W2, [W0] ; Write PM low word into program latch
	TBLWTH 	W3, [W0++] ; Write PM high byte into program latch
; 1st_program_word
	MOV 	temp_set_1, W2 ;
	TBLWTL 	W2, [W0] ; Write PM low word into program latch
	TBLWTH 	W3, [W0++] ; Write PM high byte into program latch
; 2nd_program_word
	MOV 	temp_set_2, W2 ;
	TBLWTL 	W2, [W0] ; Write PM low word into program latch
	TBLWTH 	W3, [W0++] ; Write PM high byte into program latch

; 2nd_program_word
	MOV 	temp_set_3, W2 ;
	TBLWTL 	W2, [W0] ; Write PM low word into program latch
	TBLWTH 	W3, [W0++] ; Write PM high byte into program latch

	mov		#60, w2
eeprom_ram_clear_loop:
	TBLWTL 	W3, [W0] ; Write PM low word into program latch
	TBLWTH 	W3, [W0++] ; Write PM high byte into program latch

	dec		w2, w2
	bra		NZ, eeprom_ram_clear_loop


	MOV 	#0x55, W0
	MOV 	W0, NVMKEY ; Write the 55 key
	MOV 	#0xAA, W1 ;
	MOV 	W1, NVMKEY ; Write the AA key
	BSET 	NVMCON, #WR ; Start the erase sequence
	NOP ; 2 NOPs required after setting WR
	NOP ;
	BTSC 	NVMCON, #15 ; Wait for the sequence to be completed
	BRA $-2
	return


.end











